diff --git a/Documentation/admin-guide/media/starfive_camss.rst b/Documentation/admin-guide/media/starfive_camss.rst
index 020f1969e67f..ed7fbe08f4a2 100644
--- a/Documentation/admin-guide/media/starfive_camss.rst
+++ b/Documentation/admin-guide/media/starfive_camss.rst
@@ -44,7 +44,7 @@ The Starfive Camera Subsystem hardware consists of::
 - Parallel: The parallel interface,  receiving data from a parallel sensor.

 - ISP: The ISP, processing raw Bayer data from an image sensor and producing
-  YUV frames.
+  YUV frames, and also support output 12bit per pixel Bayer format frames.


 Topology
@@ -58,20 +58,22 @@ The media controller pipeline graph is as follows:
     :alt:   starfive_camss_graph.dot
     :align: center

-The driver has 4 video devices:
+The driver has 5 video devices:

 - output_params: The meta output device, transmitting the parameters to ISP
   module.
 - capture_raw: The capture device, capturing image data directly from a sensor.
 - capture_yuv: The capture device, capturing YUV frame data processed by the
   ISP module.
+- capture_bayer: The capture device, capturing 12bit per pixel Bayer frame data
+  processed by the ISP module.
 - capture_scd: The meta capture device, capturing 3A statistics collection data
   processed by the ISP module.

 The driver has 3 subdevices:

 - stf_isp: is responsible for all the isp operations, outputs YUV frames
-  and 3A statistics collection data.
+  , 3A statistics collection data and Bayer frames.
 - cdns_csi2rx: a CSI-2 bridge supporting up to 4 CSI lanes in input, and 4
   different pixel streams in output.
 - imx219: an image sensor, image data is sent through MIPI CSI-2.
diff --git a/Documentation/admin-guide/media/starfive_camss_graph.dot b/Documentation/admin-guide/media/starfive_camss_graph.dot
index 7961255d3ad6..5255c12c2b15 100644
--- a/Documentation/admin-guide/media/starfive_camss_graph.dot
+++ b/Documentation/admin-guide/media/starfive_camss_graph.dot
@@ -1,16 +1,18 @@
 digraph board {
 	rankdir=TB
-	n00000001 [label="{{<port0> 0 | <port1> 1} | stf_isp\n/dev/v4l-subdev0 | {<port2> 2 | <port3> 3}}", shape=Mrecord, style=filled, fillcolor=green]
-	n00000001:port2 -> n0000000e
-	n00000001:port3 -> n00000012 [style=dashed]
-	n00000006 [label="output_params\n/dev/video0", shape=box, style=filled, fillcolor=yellow]
-	n00000006 -> n00000001:port1 [style=dashed]
-	n0000000a [label="capture_raw\n/dev/video1", shape=box, style=filled, fillcolor=yellow]
-	n0000000e [label="capture_yuv\n/dev/video2", shape=box, style=filled, fillcolor=yellow]
-	n00000012 [label="capture_scd\n/dev/video3", shape=box, style=filled, fillcolor=yellow]
-	n0000001c [label="{{<port0> 0} | cdns_csi2rx.19800000.csi-bridge\n/dev/v4l-subdev1 | {<port1> 1 | <port2> 2 | <port3> 3 | <port4> 4}}", shape=Mrecord, style=filled, fillcolor=green]
-	n0000001c:port1 -> n00000001:port0 [style=dashed]
-	n0000001c:port1 -> n0000000a [style=dashed]
-	n00000026 [label="{{} | imx219 6-0010\n/dev/v4l-subdev2 | {<port0> 0}}", shape=Mrecord, style=filled, fillcolor=green]
-	n00000026:port0 -> n0000001c:port0 [style=bold]
+	n00000001 [label="{{<port0> 0 | <port1> 1} | stf_isp\n/dev/v4l-subdev0 | {<port2> 2 | <port3> 3 | <port4> 4}}", shape=Mrecord, style=filled, fillcolor=green]
+	n00000001:port2 -> n0000000f [style=dashed]
+	n00000001:port4 -> n00000017 [style=dashed]
+	n00000001:port3 -> n00000013 [style=dashed]
+	n00000007 [label="output_params\n/dev/video0", shape=box, style=filled, fillcolor=yellow]
+	n00000007 -> n00000001:port1 [style=dashed]
+	n0000000b [label="capture_raw\n/dev/video1", shape=box, style=filled, fillcolor=yellow]
+	n0000000f [label="capture_yuv\n/dev/video2", shape=box, style=filled, fillcolor=yellow]
+	n00000013 [label="capture_bayer\n/dev/video3", shape=box, style=filled, fillcolor=yellow]
+	n00000017 [label="capture_scd\n/dev/video4", shape=box, style=filled, fillcolor=yellow]
+	n00000023 [label="{{<port0> 0} | cdns_csi2rx.19800000.csi\n/dev/v4l-subdev1 | {<port1> 1 | <port2> 2 | <port3> 3 | <port4> 4}}", shape=Mrecord, style=filled, fillcolor=green]
+	n00000023:port1 -> n00000001:port0 [style=dashed]
+	n00000023:port1 -> n0000000b [style=dashed]
+	n0000002d [label="{{} | imx219 6-0010\n/dev/v4l-subdev2 | {<port0> 0}}", shape=Mrecord, style=filled, fillcolor=green]
+	n0000002d:port0 -> n00000023:port0 [style=bold]
 }